<template>
	<div id="vault">
		<div class="cover"></div>
			
		<div class="outer" 
			@mousedown="startVaultRotation" 
			:style="{ transform: 'rotate('+rotation+'deg)', transition : (rotation_data.rotating)? 'none' : 'all 0.3s' }"
		>
		
			<svg>
				<g v-for="n in 4" :class="{ hidden: statActive(n) }">
					<path class="container" fill="none" v-bind:stroke="svgColor(n)" stroke-width="50" v-bind:d="renderSvgPath('outer',n)"></path>
					<path class="bar" fill="none" v-bind:stroke="svgColor(n)" stroke-width="50" v-bind:d="renderSvgPath('outer_bar',n)"></path>
				</g>
			</svg>
		
			
			<div v-for="n in 4" :class="{ hidden: statActive(n) }">
				<div class="vairus-vault-label" 
					:class="['label-'+n]"
					:style="{ transform: 'rotate('+(-1*rotation)+'deg)', transition : (rotation_data.rotating)? 'none' : 'all 0.3s' }"
				>{{ current_stats[n-1] }}</div>
			</div>
		</div>
		
		<div class="errors">
			<div v-for="n in 5" class="dot" :class="{active : n <= errors}"></div>
		</div>
		
		
		<div class="inner">
			<svg>
				<circle cx="100" cy="100" stroke="black" stroke-width="2" fill="none" r="51"></circle>
				<circle cx="100" cy="100" r="99" stroke="black" stroke-width="2" fill="none" />
				<path v-for="n in 4" fill="none" stroke="black" stroke-width="50" v-bind:d="renderSvgPath('inner',n)"></path>
			</svg>
		
			<div  v-for="n in 4">
				<div class="vairus-vault-label" 
					:class="['label-'+n]"
				>{{ defences[n-1] }}</div>
			</div>
		</div>
		
		
		<div class="hack" v-on:click="nextStep">Hack</div>
	</div>
</template>


<script>
	export default {
		props: ['vault_data'],
		data: function () {
			return{
				defences : [0,0,0,0],
				current_stats : [0,0,0,0],
				errors : 0,
				rotation_data : {
					rotating : false,
					R2D : 180 / Math.PI,
					center : {x: 0,y: 0},
					angle : 0,
					rotation : 0,
					startAngle : 0
				},
				rotation : 0
			}
		},
		created() {
			this.defences = this.$props.vault_data.defences;
			this.current_stats = this.$props.vault_data.current_stats;
			
			document.addEventListener("mousemove", this.rotate, false);
			document.addEventListener("mouseup", this.stopRotation, false);
			document.addEventListener("keydown", this.keyboardRotate, false);
		},
		beforeDestroy() {
			document.removeEventListener("mousemove", this.rotate, false);
			document.removeEventListener("mouseup", this.stopRotation, false);
			document.removeEventListener("keydown", this.keyboardRotate, false);
		},
		methods: {
			statActive(index){
				let stat = '';
				
				switch(index){
					case 1: stat = 'hazard'; break;
					case 2: stat = 'secrecy'; break;
					case 3: stat = 'adaptability'; break;
					case 4: stat = 'rapidity'; break;
				}
				
				return !this.vault_data.avaiable_stats.includes(stat);
			},
			nextStep(){
				
				chrome.runtime.sendMessage({
					type : 'vault_next_step',
					data : {
						unique_id : this.vault_data.unique_id,
						offset : ((this.rotation/90)+4)%4
					}
				}, function(response){
					console.log(response);
					if(!response.end){
						this.defences = response.defences;
						this.current_stats = response.current_stats;
						this.errors = response.errors;
					}else{
						this.stopVault(response.rewards);
					}
				}.bind(this));
			},
			stopVault(rewards){
				this.$emit('stopvault', rewards);
			},
			startVaultRotation(e){
				this.rotation_data.rotating = true;
				
				let handle = e.originalTarget.offsetParent;
				handle.style.transition = "none";
				
				let height, left, top, width, x, y, _ref;
				e.preventDefault();
				_ref = handle.getBoundingClientRect(), top = _ref.top, left = _ref.left, height = _ref.height, width = _ref.width;
				this.rotation_data.center = {
					  x: left + (width / 2),
					  y: top + (height / 2)
				};
				x = e.clientX - this.rotation_data.center.x;
				y = e.clientY - this.rotation_data.center.y;
				this.rotation_data.startAngle = this.rotation_data.R2D * Math.atan2(y, x);
			},
			rotate(e){
				let d, x, y;
				e.preventDefault();
				x = e.clientX - this.rotation_data.center.x;
				y = e.clientY - this.rotation_data.center.y;
				d = this.rotation_data.R2D * Math.atan2(y, x);
				this.rotation_data.rotation = d - this.rotation_data.startAngle;
				if (this.rotation_data.rotating) {
					this.rotation = this.rotation_data.angle + this.rotation_data.rotation;
				}
			},
			stopRotation(){
				if(this.rotation_data.rotating){
					let rounded = Math.round((this.rotation_data.angle + this.rotation_data.rotation)/90)*90;
					this.rotation = rounded;
					
					this.rotation_data.angle = rounded;
					this.rotation_data.rotating = false;
				}
			},
			keyboardRotate(e){
				switch(e.which) {
					case 37: // left
						this.rotation-=90;
						this.rotation_data.angle = this.rotation;
					break;
					case 39: // right
						this.rotation+=90;
						this.rotation_data.angle = this.rotation;
					break;
				}
			},
			svgColor(index){
				switch(index){
					case 1: return '#007bff'; break;
					case 2: return '#944464'; break;
					case 3: return '#473f3b'; break;
					case 4: return '#559444'; break;
				}
			},
			renderSvgPath(type,i){
				let start_angle = (90*i)-135;
				let end_angle = (90*i)-45;
				let center = 0;
				let radius = 0;
				
				switch(type){
					case 'outer':
						center = 200;
						radius = 175;
					break;
					case 'outer_bar':
						center = 200;
						radius = 175;
						
						var max_value = Math.max(...this.defences)+1;
						var total_angle = (this.current_stats[i-1]*90)/max_value;
						total_angle = Math.min(total_angle, 90);
						
						start_angle+= (90-total_angle)/2;
						end_angle-= (90-total_angle)/2;
					break;
					case 'inner':
						center = 100;
						radius = 75;
						
						var max_value = Math.max(...this.defences)+1;
						var total_angle = (this.defences[i-1]*90)/max_value;
						
						start_angle+= (90-total_angle)/2;
						end_angle-= (90-total_angle)/2;
					break;
				}
				
				return this.describeArc(center, center, radius, start_angle, end_angle);
			},
			describeArc(x, y, radius, startAngle, endAngle){

				let start = this.polarToCartesian(x, y, radius, endAngle);
				let end = this.polarToCartesian(x, y, radius, startAngle);

				let largeArcFlag = endAngle - startAngle <= 180 ? "0" : "1";

				let d = [
					"M", start.x, start.y, 
					"A", radius, radius, 0, largeArcFlag, 0, end.x, end.y
				].join(" ");

				return d;       
			},
			polarToCartesian(centerX, centerY, radius, angleInDegrees) {
				let angleInRadians = (angleInDegrees-90) * Math.PI / 180.0;

				return {
					x: centerX + (radius * Math.cos(angleInRadians)),
					y: centerY + (radius * Math.sin(angleInRadians))
				};
			}
		}
	}
</script>


<style lang="scss" scoped>
	#vault{
		position: fixed;
		left: 50%;
		top: 50%;
		width: 400px;
		height: 400px;
		transform: translate(-50%, -50%);
		z-index: 2147483647;
		
		.hidden{
			visibility: hidden;
		}
		
		.cover{
			position: absolute;
			background-color: white;
			left: 0;
			top: 0;
			width: 100%;
			height: 100%;
			border-radius: 50%;
		}
		
		
		.outer{
			position: relative;
			width: 100%;
			height: 100%;
			cursor: pointer;
			
			svg{
				position: absolute;
				width: 400px;
				height: 400px;
				left: 0;
				top: 0;
				pointer-events: none;
				
				.container{
					opacity: 0.2;
				}
			}
			
			.vairus-vault-label{
				position: absolute;
				color: white;
				font-weight: bold;
				
				&.label-1{
					top: 17px;
					left: calc(50% - 9px);
				}
				&.label-2{
					right: 17px;
					top: calc(50% - 9px);
				}
				&.label-3{
					bottom: 17px;
					left: calc(50% - 9px);
				}
				&.label-4{
					left: 17px;
					top: calc(50% - 9px);
				}
			}
		}
		
		.inner{
			svg{
				position: absolute;
				width: 200px;
				height: 200px;
				left: 100px;
				top: 100px;
			}
		
			.vairus-vault-label{
				position: absolute;
				color: white;
				font-weight: bold;
				width: 30px;
				text-align: center;
				
				&.label-1{
					top: calc(50% - 80px);
					left: calc(50% - 15px);
				}
				&.label-2{
					right: calc(50% - 80px);
					top: calc(50% - 9px);
				}
				&.label-3{
					bottom: calc(50% - 80px);
					left: calc(50% - 15px);
				}
				&.label-4{
					left: calc(50% - 80px);
					top: calc(50% - 9px);
				}
			}
			
		}

		.errors{
			position: absolute;
			width: 80%;
			top: 78%;
			left: 10%;
			text-align: center;
			pointer-events: none;
			
			.dot{
				display: inline-block;
				width: 10px;
				height: 10px;
				border: 1px solid black;
				border-radius: 50%;
				margin: 0 5px;
				
				&.active{
					background-color: red;
					border-color: red;	
				}
			}
		}
		
		.hack{
			position: absolute;
			border-radius: 50%;
			left: 50%;
			top: 50%;
			width: 100px;
			height: 100px;
			transform: translate(-50%, -50%);
			background-color: white;
			color: black;
			text-align: center;
			line-height: 100px;
			cursor: pointer;
			text-transform: uppercase;
			font-weight: bold;
		}
	}
</style>
